﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace RobotCtrl
{
    
    public class Console
    {
        private DigitalIn switches;
        public DigitalIn Switches
        {
            get { return switches; }
        }
        private DigitalIn switches_laststate;

        private DigitalOut lamps;
        public DigitalOut Lamps
        {
            get { return lamps; }
        }

        /// <summary>
        /// Default construction for virtual environment
        /// </summary>
        public Console()
            :this(Config.IsWinCE ? RunMode.REAL : RunMode.VIRTUAL)
        {}

        /// <summary>
        /// Constructor to chose between virtual and real runmodes
        /// </summary>
        /// <param name="mode"></param>
        public Console(RunMode mode)
        {
            if (mode == RunMode.VIRTUAL)
            {
                switches = new DigitalIn();
                lamps = new DigitalOut();
            }
            else
            {
                switches = new DigitalIn_HW(Config.IOConsoleSwitches);
                lamps = new DigitalOut_HW(Config.IOConsoleLeds);
            }

            //Initialise polling timer
            TimerCallback cb = new TimerCallback(PollSwitches);
            Timer timer = new Timer(cb, null, 0, 100);

        }

        private void PollSwitches(object state)
        {
            this.switches_laststate = this.switches;
        }



    }
}
