using System;
using System.Collections.Generic;
using System.Text;

namespace RobotCtrl
{
    public sealed class DriveInfo
    {
        private readonly PositionInfo position = new PositionInfo();
        public PositionInfo Position { get { return position; } }

        public double Runtime { get; set; }
        public double SpeedL { get; set; }
        public double SpeedR { get; set; }
        public double DistanceL { get; set; }
        public double DistanceR { get; set; }
        public int DriveStatus { get; set; }
        public int MotorStatusL { get; set; }
        public int MotorStatusR { get; set; }

        public DriveInfo()
        {
        }

        public DriveInfo(PositionInfo position,
            double runtime,
            double speedL, double speedR,
            double distanceL, double distanceR,
            int driveStatus,
            int motorStatusL, int motorStatusR
            )
        {
            Runtime = runtime;
            SpeedL = speedL;
            SpeedR = speedR;
            DistanceL = distanceL;
            DistanceR = distanceR;
            DriveStatus = driveStatus;
            MotorStatusL = motorStatusL;
            MotorStatusR = motorStatusR;
        }

        public void SetMembersFrom(DriveInfo other)
        {
            this.Position.SetMembersFrom(other.Position);
            this.Runtime = other.Runtime;
            this.SpeedL = other.SpeedL;
            this.SpeedR = other.SpeedR;
            this.DistanceL = other.DistanceL;
            this.DistanceR = other.DistanceR;
            this.DriveStatus = other.DriveStatus;
            this.MotorStatusL = other.MotorStatusL;
            this.MotorStatusR = other.MotorStatusR;
        }
    }
}
