using System;
using System.Collections.Generic;
using System.Text;

namespace RobotCtrl
{
    public class Radar
    {
        private readonly RadarSensorBase sensor;

        public double Distance { get { return sensor.Distance; } }

        private readonly PositionInfo antennaPosition = new PositionInfo();
        public PositionInfo AntennaPosition { get { return antennaPosition; } }

        public Radar(Robot robot, RunMode mode)
        {
            if (!Config.IsWinCE)
                mode = RunMode.VIRTUAL;
            if (mode == RunMode.VIRTUAL)
            {
                antennaPosition.X = robot.Dimensions.Width / 2;
                antennaPosition.Y = robot.Dimensions.Height / 2;
                antennaPosition.Angle = 90;
                sensor = new RadarSensor(robot.Position, antennaPosition);
            }
            else
            {
                sensor = new RadarSensor_HW(Config.IORadarSensor);
            }
        }
    }
}
