﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace RobotCtrl
{
    public class Robot
    {
        private Drive drive;
        public Drive Drive
        {
            get { return drive; }
        }

        //private InputController inputController;
        //public InputController InputController
        //{
        //    get { return inputController; }
        //}

        private Console console;
        public Console Console
        {
            get { return console; }
        }

        public PositionInfo Position { get { return drive.Position; } }

        private Color color;
        public Color Color
        {
            get { return color; }
            set { color = value; }
        }

        private Color borderColor;
        public Color BorderColor
        {
            get { return borderColor; }
            set { borderColor = value; }
        }


        private Radar radar;
        public Radar Radar
        {
            get { return radar; }
            set { radar = value; }
        }

        private SizeF dimensions = new SizeF(0.25f, 0.25f);
        public SizeF Dimensions
        {
            get { return dimensions; }
        }

        public Robot(RunMode runMode)
        {
            this.drive = new Drive(runMode);
            //this.inputController = new JoystickInputController();
            this.console = new Console(runMode);
            this.radar = new Radar(this, runMode);
            Random rand = new Random();
            this.color = Color.FromArgb(Convert.ToInt32(rand.NextDouble()*255), Convert.ToInt32(rand.NextDouble()*255), Convert.ToInt32(rand.NextDouble()*255));
            this.borderColor = Color.FromArgb(Convert.ToInt32(rand.NextDouble() * 255), Convert.ToInt32(rand.NextDouble() * 255), Convert.ToInt32(rand.NextDouble() * 255));
        }
    }
}
