﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace RobotView
{
    public partial class ConsoleView : UserControl
    {
        public ConsoleView()
        {
            InitializeComponent();
        }

        private RobotCtrl.Console console;

        public ConsoleView(RobotCtrl.Console console):this()
        {
            this.console = console;

            Timer timer = new Timer();
            timer.Interval = 100;
            timer.Enabled = true;
            timer.Tick += new EventHandler(timer_Tick);
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            console.Lamps.Data = console.Switches.Data;
            for (int i = 0; i < LampViewList.Count; i++)
            {
                //assign lamp control bit to appropriate lamp
                LampViewList[i].State = console.Lamps[i];

                //assign switch control bit to appropriate switch
                SwitchViewList[i].Switch = console.Switches[i];
            }
        }

        private List<LampView> LampViewList;
        private List<SwitchView> SwitchViewList;

        public void InitLampsAndSwitches(int count)
        {
            this.Size = new Size(0, 0);
            LampViewList = new List<LampView>();
            SwitchViewList = new List<SwitchView>();

            for (int i = 0; i < count; i++)
            {
                Label lbl = new Label();
                lbl.Width = 20;
                lbl.Height = 20;
                lbl.ForeColor = Color.White;
                lbl.BackColor = Color.Black;
                lbl.Text = (i + 1).ToString();
                lbl.Location = new Point(lbl.Width * i, 0);
                this.Controls.Add(lbl);

                LampView lamp = new LampView(console.Lamps, i);
                lamp.Location = new Point(lamp.Width * i, lbl.Height);
                LampViewList.Add(lamp);
                this.Controls.Add(lamp);

                SwitchView swtch = new SwitchView(console.Switches, i);
                swtch.Location = new Point(swtch.Width * i, lbl.Height + lamp.Height);
                SwitchViewList.Add(swtch);
                this.Controls.Add(swtch);

                //set control bounds
                this.Size = new Size(swtch.Width * (i+1), lbl.Height + lamp.Height + swtch.Height);

            }
        }
    }
}
