﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using RobotCtrl;
using RobotView;

namespace Test_Console
{
    public partial class ConsoleForm : Form
    {
        private RobotCtrl.Console console;
        private Thread thread1;

        public ConsoleForm()
        {
            InitializeComponent();

            //use component RobotCtrl
            console = new RobotCtrl.Console();
            console.Lamps.Data = 0xFFFFFFF; //Assign bit pattern
            console.Lamps[0] = false;       //Bit shift
            console.Lamps[1] = false;       //Bit shift
            console.Lamps[2] = false;       //Bit shift

            //MessageBox.Show(Convert.ToString(console.Lamps.Data, 2)); // output as binary

            //use component "ConsoleView"
            ConsoleView consoleView = new ConsoleView(console);
            consoleView.InitLampsAndSwitches(16);   //max 32bit (limitation of int32)
            this.Controls.Add(consoleView);

            thread1 = new System.Threading.Thread(runAnimation);
            thread1.Start();
        }

        private void runAnimation()
        {
            while (true)
            {
                console.Switches.Data = console.Switches.Data+1;
                Thread.Sleep(1000);
            }
        }

        private void ConsoleForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            thread1.Abort();
        }
    }
}
