﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using RobotCtrl;
using RobotView;

namespace Test_Console_CE
{
    public partial class ConsoleFormCE : Form
    {        
        private RobotCtrl.Console console;
        private Thread thread1;

        public ConsoleFormCE()
        {
            InitializeComponent();

            //use component RobotCtrl
            console = new RobotCtrl.Console();
            console.Lamps.Data = 0xFFFFFFF; //Assign bit pattern
            console.Lamps[0] = false;       //Bit shift
            console.Lamps[1] = false;       //Bit shift
            console.Lamps[2] = false;       //Bit shift

            //MessageBox.Show(Convert.ToString(console.Lamps.Data, 2)); // output as binary

            //use component "ConsoleView"
            ConsoleView consoleView = new ConsoleView(console);
            consoleView.InitLampsAndSwitches(16);   //max 32bit (limitation of int32)
            this.Controls.Add(consoleView);

            // used to animate in virtual mode
            if (!Config.IsWinCE)
            {
                thread1 = new System.Threading.Thread(runAnimation);
                thread1.Start();
            }
             
        }

        private void runAnimation()
        {
            while (true)
            {
                console.Switches.Data = console.Switches.Data+1;
                Thread.Sleep(1000);
            }
        }

        private void ConsoleFormCE_Closing(object sender, CancelEventArgs e)
        {
            if (this.thread1 != null)
            {
                this.thread1.Abort();
            }
        }


    }
}