﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Windows.Forms;
using Chart;
using RobotCtrl;
using System.Drawing;
using RobotView;

namespace Test_Console_CE
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [MTAThread]
        static void Main()
        {
            //Application.Run(new ConsoleFormCE());
            //Application.Run(new MotorControl());
            //Application.Run(new ChartForm());
            //Application.Run(new DriveForm());
            //Application.Run(new TestWorld());
            setupPylonRace();
        }

        private static void setupPylonRace()
        {
            var robot = new Robot(RunMode.VIRTUAL);
            robot.Position.X = 0;
            robot.Position.Y = -1;
            robot.Drive.Power = true;
            World.Robots.Add(robot);

            // Obstacles kreieren und in World einfügen
            /*
            World.Obstacles.Add(new ObstacleMap("Resources\\Pylon.bmp",
                new RectangleF(0.875f, 0.375f, 0.25f, 0.25f)));
            World.Obstacles.Add(new ObstacleMap("Resources\\Pylon.bmp",
                new RectangleF(4.875f, 0.375f, 0.25f, 0.25f)));
            */

            World.Obstacles.Add(new ObstacleMap("Resources\\Raceway.png",
                new RectangleF(-0.5f, -1.5f, 4.0f, 2.0f)));

            var worldForm = new WorldForm(World.Area);
            worldForm.Text = "..:: Pylon Race ::..";
            worldForm.Show();
            worldForm.Height = Screen.PrimaryScreen.WorkingArea.Height - 200;
            worldForm.Width = Screen.PrimaryScreen.WorkingArea.Height - 200;
            worldForm.Location = new Point(Screen.PrimaryScreen.WorkingArea.Width - worldForm.Width, 0);

            robot.Drive.RunATrack(new TrackPylons(2, 1, robot.Radar));

            //var controllerForm = new ControllerForm(robot.InputController);
            //controllerForm.Show();

            var consoleForm = new ConsoleForm(robot.Console);
            consoleForm.TopMost = true;
            consoleForm.Text = "Console";
            consoleForm.ControlBox = false;
            consoleForm.Show();
            consoleForm.Location = new Point(0, 0);

            Application.Run(worldForm);
            // Exit Main Thread (CF does not do this automatically)
            System.Threading.Thread.CurrentThread.Abort();
        }
    }
}